# -*- coding: utf-8 -*-
# This script was auto-generated by Sim4Life version 8.2.0.16876

import numpy
import s4l_v1.analysis as analysis
import s4l_v1.document as document
import s4l_v1.model as model
import s4l_v1.units as units
from s4l_v1 import ReleaseVersion
from s4l_v1 import Unit
import numpy as np


# Creating the analysis pipeline
# Adding a new SimulationExtractor
simulation = document.AllSimulations["EM Electrodes Stimulation"]
simulation_extractor = simulation.Results()

# Adding a new EmSensorExtractor
em_sensor_extractor = simulation_extractor["Overall Field"]
em_sensor_extractor.FrequencySettings.ExtractedFrequency = u"All"
document.AllAlgorithms.Add(em_sensor_extractor)

# Adding a new CurrentExtractor
inputs = [em_sensor_extractor.Outputs["EM Potential(x,y,z,f0)"], em_sensor_extractor.Outputs["J(x,y,z,f0)"]]
current_extractor = analysis.extractors.CurrentExtractor(inputs=inputs)
current_extractor.UpdateAttributes()
document.AllAlgorithms.Add(current_extractor)

# Adding a new DataTableHTMLViewer
output = current_extractor.Outputs["Total Flux(J(x,y,z,f0))"]
output.Update()
comp = output.Data.GetComponent(0) 
flux = np.real(comp)[0]


inputs = [em_sensor_extractor.Outputs["EM E(x,y,z,f0)"]]
user_defined_field_normalizer = analysis.field.UserDefinedFieldNormalizer(inputs=inputs)
user_defined_field_normalizer.Target.Value = 1/(flux*1000)
user_defined_field_normalizer.UpdateAttributes()
document.AllAlgorithms.Add(user_defined_field_normalizer)

inputs = [user_defined_field_normalizer.Outputs["EM E(x,y,z,f0)"]]
slice_field_viewer = analysis.viewers.SliceFieldViewer(inputs=inputs)
slice_field_viewer.Data.Mode = slice_field_viewer.Data.Mode.enum.QuantityComplexModulus
slice_field_viewer.Data.Component = slice_field_viewer.Data.Component.enum.ComponentsAll
slice_field_viewer.Slice.Index = 169
slice_field_viewer.UpdateAttributes()
document.AllAlgorithms.Add(slice_field_viewer)

